<?php

namespace App\Controller;

use App\Entity\Domain;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Attribute\Route;
use Symfony\Component\Security\Http\Attribute\IsGranted;
use Symfony\Component\Validator\Constraints\NotBlank;
use Symfony\Component\Validator\Validator\ValidatorInterface;

class DomainCommentController extends AbstractController
{
    #[Route('/api/domain/{id}/comment', name: 'app_api_comment_add')]
    #[IsGranted('IS_AUTHENTICATED_FULLY')]
    public function addCommentAPI(ValidatorInterface $validator)
    {
        $validator->validate([
            '' => new NotBlank()
        ]);
    }

    #[Route('/domain/{id}/comment', name: 'app_domain_comments')]
    #[IsGranted('IS_AUTHENTICATED_FULLY')]
    public function index(Domain $domain): Response
    {
        return $this->render('domain_comment/index.html.twig', [
            'domain' => $domain,
            'controller_name' => 'DomainCommentController',
        ]);
    }
}
